package com.mwq.frame.common;

import java.awt.BorderLayout;
import java.util.Iterator;
import java.util.Set;

import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;

import com.mwq.hibernate.Dao;
import com.mwq.hibernate.mapping.TbDept;

public class DeptTreeDialog extends JDialog {

	private JTree tree;

	private Dao dao;

	public DeptTreeDialog(final JTextField textField) {
		super();
		dao = Dao.getInstance();
		setModal(true);// öԻֹǰ߳
		setUndecorated(true);// öԻṩ
		setBounds(100, 100, 125, 175);

		final JScrollPane scrollPane = new JScrollPane();// 
		getContentPane().add(scrollPane, BorderLayout.CENTER);

		TbDept company = (TbDept) dao.queryDeptById(1);
		DefaultMutableTreeNode root = new DefaultMutableTreeNode(company
				.getName());// ĸڵ

		Set depts = company.getTbDepts();
		for (Iterator deptIt = depts.iterator(); deptIt.hasNext();) {
			TbDept dept = (TbDept) deptIt.next();
			DefaultMutableTreeNode deptNode = new DefaultMutableTreeNode(dept
					.getName());// Ķӽڵ
			root.add(deptNode);
			Set sonDepts = dept.getTbDepts();
			for (Iterator sonDeptIt = sonDepts.iterator(); sonDeptIt.hasNext();) {
				TbDept sonDept = (TbDept) sonDeptIt.next();
				deptNode.add(new DefaultMutableTreeNode(sonDept.getName()));// Ҷӽڵ
			}
		}

		DefaultTreeModel treeModel = new DefaultTreeModel(root); // øڵ󴴽ģͶ

		tree = new JTree(treeModel); // ģͶ󴴽
		DefaultTreeCellRenderer render = new DefaultTreeCellRenderer();
		render.setLeafIcon(new ImageIcon());// Ҷӽͼ
		render.setClosedIcon(new ImageIcon());// ý۵ʱͼ
		render.setOpenIcon(new ImageIcon());// ýչʱͼ
		tree.setCellRenderer(render);
		tree.addTreeSelectionListener(new TreeSelectionListener() {// ڵ㱻ѡе¼
					public void valueChanged(TreeSelectionEvent e) {
						TreePath treePath = e.getPath();// ñѡڵ·
						DefaultMutableTreeNode node = (DefaultMutableTreeNode) treePath
								.getLastPathComponent();// ñѡڵĶ
						if (node.getChildCount() == 0) {// ѡеĽڵΪҶӽڵ
							textField.setText(node.toString());// ѡнڵʾı
						} else {// ѡеĽڵ㲻Ҷӽڵ
							JOptionPane.showMessageDialog(null, "ѡڵľ岿",
									"ʾ", JOptionPane.ERROR_MESSAGE);
							return;
						}
						dispose();// ٲԻ
					}
				});
		scrollPane.setViewportView(tree); // ŵ
		//
	}

}
